diff --git a/hw/blizzard.c b/hw/blizzard.c
index 5f329ad..7cbb358 100644
--- a/hw/blizzard.c
+++ b/hw/blizzard.c
@@ -7,7 +7,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/blizzard_template.h b/hw/blizzard_template.h
index 42f4e90..e9f130f 100644
--- a/hw/blizzard_template.h
+++ b/hw/blizzard_template.h
@@ -7,7 +7,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/cbus.c b/hw/cbus.c
index 8ae24e0..61cfca6 100644
--- a/hw/cbus.c
+++ b/hw/cbus.c
@@ -9,7 +9,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/lm832x.c b/hw/lm832x.c
index ce7dcac..5d575ba 100644
--- a/hw/lm832x.c
+++ b/hw/lm832x.c
@@ -7,7 +7,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/nseries.c b/hw/nseries.c
index 0273eee..2013354 100644
--- a/hw/nseries.c
+++ b/hw/nseries.c
@@ -1,13 +1,14 @@
 /*
  * Nokia N-series internet tablets.
  *
- * Copyright (C) 2007 Nokia Corporation
- * Written by Andrzej Zaborowski <andrew@openedhand.com>
+ * Copyright (C) 2007-2009 Nokia Corporation
+ * N800/N810 support written by Andrzej Zaborowski <andrew@openedhand.com>
+ * N900 support written by Juha Riihimäki
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/omap2.c b/hw/omap2.c
index a3fa89d..69b6ea8 100644
--- a/hw/omap2.c
+++ b/hw/omap2.c
@@ -1,13 +1,13 @@
 /*
  * TI OMAP processors emulation.
  *
- * Copyright (C) 2007-2008 Nokia Corporation
+ * Copyright (C) 2007-2009 Nokia Corporation
  * Written by Andrzej Zaborowski <andrew@openedhand.com>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/onenand.c b/hw/onenand.c
index c1e7e4d..b447726 100644
--- a/hw/onenand.c
+++ b/hw/onenand.c
@@ -1,13 +1,13 @@
 /*
  * OneNAND flash memories emulation.
  *
- * Copyright (C) 2008 Nokia Corporation
+ * Copyright (C) 2008-2009 Nokia Corporation
  * Written by Andrzej Zaborowski <andrew@openedhand.com>
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/soc_dma.c b/hw/soc_dma.c
index e116e63..8147ed5 100644
--- a/hw/soc_dma.c
+++ b/hw/soc_dma.c
@@ -7,7 +7,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/tmp105.c b/hw/tmp105.c
index 8343aff..9fae2e4 100644
--- a/hw/tmp105.c
+++ b/hw/tmp105.c
@@ -7,7 +7,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/tusb6010.c b/hw/tusb6010.c
index 3887233..284245b 100644
--- a/hw/tusb6010.c
+++ b/hw/tusb6010.c
@@ -8,7 +8,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
diff --git a/hw/twl92230.c b/hw/twl92230.c
index e61f17f..81f41e0 100644
--- a/hw/twl92230.c
+++ b/hw/twl92230.c
@@ -8,7 +8,7 @@
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
  * published by the Free Software Foundation; either version 2 or
- * (at your option) version 3 of the License.
+ * (at your option) any later version of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of